;
; bank3.asm - bank3 assembler
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
BANK		= 3
;Do not use jsr $ffe4, $ffcf, $ffd2 in this bank!!!

		.include config.def
		.include makro.def
		.include consts.def
		.include external.ram
		.include internal.ram

		*= $8000

		.fill $4000,$aa

		*= $a000
		.if DE32_EXISTS=0
config16test	.byte $ff
		.fi
		.byte $ff,$ff,$ff
		.include crosslnk.asm

		.include console.asm
		.include dir.asm
		.include messages.asm
;		.include console80.asm
		.include basicwedge.asm

buffer_start	.for iodhtoe=0,iodhtoe<MAX_BUFFERS,iodhtoe=iodhtoe+1
		.byte iodhtoe*8+ram_exp_buff_avail0
		.next

monitor
		sei
		cld

		tax
		lda monitor_ripper_exp
		bne monitor_start.mon_rip_start
		#stx_l_a monitor_oldbank_exp

		lda $00
		sta monitor_data_exp
		lda #255
		sta $00
		lda $01
		sta monitor_data_exp+1
		#stz_a $00
		jmp monitor_start

		.include lowlevel.asm	;duplicated code!
		.include ram.asm	;duplicated code!
		.include ideserv.asm
                .if PCLINK_USECRC
                .include crc.asm
                .fi

		.include misc.asm	;duplicated code!
		.include trap.asm

		*= $8000

		.include mon.asm

		.if *>$9e5f
		.error "Bank3 block $8000-$9e60 over!"
		.fi
