;
; errors.asm - DOS error channel messages
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
messages	.text 0+$80,"OK"
		.text 1+$80,"FILES SCRATCHED"
		.text 2+$80,"PARTITION SELECTED"
		.text 20+$80,21+$80,22+$80,23+$80,"READ",0
		.text 25+$80,28+$80,"WRITE",0
		.text 26+$80,"WRITE PROTECT ON"
		.text 29+$80,"DISK CHANGED"
		.text 30+$80,32+$80,33+$80,34+$80,"SYNTAX",0
		.text 31+$80,"UNKNOWN COMMAND"
		.text 39+$80,"PATH NOT FOUND"
		.text 50+$80,"SEEK BEYOND END"
;                .text 51+$80,"OVERFLOW IN RECORD"
;                .text 52+$80,"FILE TOO LARGE"
;                .text 60+$80,"WRITE FILE OPEN"
;                .text 61+$80,"FILE NOT OPEN"
		.text 62+$80,"FILE NOT FOUND"
		.text 63+$80,"FILE EXISTS"
		.text 64+$80,"FILE TYPE MISMATCH"
		.text 66+$80,67+$80,"ILLEGAL REQUEST"
		.text 70+$80,"NO CHANNEL"
		.text 71+$80,"DIR",0
;                .text 72+$80,"PARTITION FULL"
		.text 73+$80,"IDE DOS "	;System message
		#version
		.byte 32
		.text 74+$80,"DRIVE NOT READY"
		.text 75+$80,"FORMAT",0
;                .text 76+$80,"CONTROLLER",0
		.text 77+$80,"SELECTED PARTITION ILLEGAL"
		.text $80," ERROR"
		.text 10+$80,"IDE64"	;HardDisk
		.text 11+$80,"CDROM"	;CDROM
		.text 12+$80,"ZIP64"	;ZipDrive
		.byte $80

LWOP_setdosvmsg	.proc
		jsr OP_get_current_drive_type
		asl
		php
		asl
		lda #5
		rol
		plp
		adc #0
		pha
		lda #73
		jsr LWOP_disk_status.in
		pla
		#jmps LWOP_disk_status_more
;-----------------------------------
;Set disk status from A       POM1,POM2 used!!!
;-----------------------------------
LWOP_disk_status .proc
		cmp #73
		beq LWOP_setdosvmsg
in		pha
		#ldatax current_drive_exp
		#lda0
		sta pom1
		sta status_pos_exp,x
		txa
		lsr
		ror			;*64
		ror
		tax
		pla
		pha
		jsr append_status_dec2
		lda #","
		jsr append_status
		lda #$20
		jsr append_status
		ldy #<messages
		lda #>messages
		sta pom2
		pla
LWOP_disk_status_more .proc
		ora #$80
snm		cmp (pom1),y		;!!!!!!!!! not cmp_zp_y!
		beq snmbe
		iny
		bne snm
		inc pom2
		bne snm

dsd2		lda (pom1),y		;!!!!!!!!! not lda_zp_y!
		beq LWOP_disk_status_more;append " ERROR"
		bpl msg_betu		;normal text
		txa
		and #63
		cmp #5
		bcs snm2		;end of text reached
		bcc snmbe
msg_betu	jsr append_status
snmbe		iny
		bne dsd2
		inc pom2
		bne dsd2
snm2		rts
		.pend

append_status_dec .proc
		pha
		lda #","
		jsr append_status
		pla
		ldy #47
		sec
		iny
		sbc #100
		bcs *-3
		adc #100
		pha
		tya
		jsr append_status
		pla
append_status_dec2 .proc
		ldy #47
		sec
		iny
		sbc #10
		bcs *-3
		adc #58
		pha
		tya
		jsr append_status
		pla

append_status	.proc
		sta drive_status_exp,x
		inx
		rts
		.pend
