;
; man_hi.asm - File manager upper half
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;---------------------------
;ONLY THOSE MANAGER ROUTINES ARE HERE THAT HAVE TO USE MEMORY AT $8000-$9FFF!
;---------------------------
; Print directory into panel
;
printdir	.proc
		sei
		ldx #<$450
		lda #>$450
		ldy man_selectedwin
		beq *+6
		ldx #<$630
		lda #>$630

		stx m_p2
		stx m_p3
		sta m_p2+1
		eor #$d8^$04
		sta m_p3+1

		lda man_el_l,y
		sta m_p5
		lda man_el_h,y
		sta m_p5+1

		lda #11
		sta m_p4

		dec $1
                
lop		ldy man_selectedwin
		lda m_p5
		cmp man_files_l,y
		lda m_p5+1
		sbc man_files_h,y
		bcc uii

		lda #32
		ldy #27
ug		sta (m_p2),y
		dey
		bpl ug
		lda m_p2
		adc #40-1
		#jmps ide

uii		lda m_p5
		ldy m_p5+1
		cpy #1
		jsr calc_filepos

		ldy #26
		lda (m_p1),y
		bmi sel			;selected?
		dey
		lda (m_p1),y
sel		ldy #27
ui		sta (m_p3),y
		dey
		bpl ui
		inc m_p5
		bne *+4
		inc m_p5+1

		ldy #0
                .if SUPERCPU=1
		lda (m_p1),y
		tax
                .else
                lax (m_p1),y
                .fi
		iny
		lda (m_p1),y
		inc $1
		jsr numtoasc16
		dec $1
		lda #32
r		cpy #5
		bcs i
		sta (m_p2),y
		iny
		bne r
i
		lda m_p2
		clc
		adc #3
		sta m_p2
		bcc *+4
		inc m_p2+1
		ldy #2
ly		.if SUPERCPU=1
		lda (m_p1),y
		tax
		.else
		lax (m_p1),y
		.fi
		lda cconv,x
		sta (m_p2),y
		iny
		cpy #25
		bne ly

		lda m_p2
		adc #40-3-1
ide		sta m_p2
		sta m_p3
                bcc cs
		inc m_p2+1
		inc m_p3+1

cs		dec m_p4
		bne lop
                
		inc $1
		cli
		rts
		.pend
;---------------------------
; Load directory from drive
;
mloaddir	.proc

		ldx #<$4cc
		ldy #>$4cc
		lda man_selectedwin
                php
		beq *+6
		ldx #<$6ac
		ldy #>$6ac
		jsr drawwin
                .word $0000
		.byte 18,4
		.word manager.txtloading

		dec $1

                ldx #2
lu		lda part,x
		sta man_input,x
                dex
                bpl lu

		lda #1
                ldx #<man_input
                ldy #>man_input
                jsr $ffbd

		ldx #$e0
		stx m_p2
		ldy #>man_dirmem1
		plp
		beq *+4
		ldy #>man_dirmem2
		dey
		sty m_p2+1
		#lda0
		sta ActualSecAddr
		jsr newload_t
		lda Status
		eor #$40
		bne gond
		bcc noerr

gond    	lda #32
                tay
l		dey
		sta (m_p2),y		;erase disklabel
		bne l
		ldx man_selectedwin
		tya
		sta man_files_l,x
		sta man_files_h,x
		sta man_fulllo,x
		sta man_fullhi,x
		sta man_fullfree,x
		sta man_partition,x
                sec
		gcs null

noerr		#phx_a
		ldx man_selectedwin
                tya
                clc
		sbc dirm,x
		sta m_p3
                cmp #$3f
                bcc mv
                bne nc
                pla
                cmp #$df
                bcc mv2
		.byte SKIP1
nc		pla
		inc $1
		jsr savewin
                .word $05bc
		.byte 18,4

		jsr drawwin
                .word $05bc
		.byte 18,4
		.word manager.txttoomany
                
                lda 198
                beq *-2
                dec 198

		jsr restorewin
                dec $1
                
                ldx man_selectedwin
                lda #$3f
                sta m_p3
                lda #$df
                .byte SKIP1
mv		pla
mv2
                ldy #5
ij		lsr m_p3
		ror
                dey
                bne ij
		sty m_p2
		sty m_p4

		sta man_files_l,x
		eor #255
		clc
		adc #1
		sta m_p5
		lda m_p3
		sta man_files_h,x
		eor #255
		adc #0
		sta m_p5+1
                lda dirm,x
                sta m_p2+1

		ldy #$e2
		lda (m_p2),y
		sta man_partition,x
		inc m_p2+1


		lda #<man_sort1_l
		sta m_p3
		sta m_p1
		ldy sortm,x
		sty m_p3+1
		iny
		iny
		sty m_p1+1

		ldy man_floppy,x
		bne flo
		lda #<man_pontpont
		sta (m_p3),y
		lda #>man_pontpont
		sta (m_p1),y
		inc m_p3
		inc m_p1
		inc man_files_l,x
		bne flo
		inc man_files_h,x

flo		bcs null2		;empty dir

p		ldy #0
		.if SUPERCPU=1
                lda (m_p2),y
                tax
                .else
		lax (m_p2),y
		.fi
		iny
		lda (m_p2),y
		pha			;copy filesize
                lda #34
	      	iny
ll		cmp (m_p2),y
		beq mc
                inc m_p2
		bne ll

mc              ldy #0
		lda m_p2
                sta (m_p3),y
		lda m_p2+1
                sta (m_p1),y
                txa
                sta (m_p2),y
                iny
                pla
                sta (m_p2),y
                iny
                lda #34
ll2      	iny          		;012345678901234567890123456
		cmp (m_p2),y 		;xx"1234567890123456"*PRG<AB
		bne ll2
                #lda0
                sta (m_p2),y

                ldy #21
		lda (m_p2),y
		cmp #"D"
		bne nd
		iny
		lda (m_p2),y
		cmp #"I"
		bne nd
		iny
		lda (m_p2),y
		cmp #"R"
		bne nd

		ldy #3
		lda (m_p2),y
		cmp #"."
		bne nemp
		iny
		lda (m_p2),y
		beq rh			;"." found
		iny
		eor #"."
		ora (m_p2),y		;".." found
		bne nemp
rh		ldx man_selectedwin
		lda man_files_l,x
		bne h
		dec man_files_h,x	;".." and "." not counts...
h		dec man_files_l,x
		#jmps id

		.if SUPERCPU=1
nemp		ldx #0
		.BYTE SKIP2
nd		ldx #1

		lda manager_dircolor_exp,x

		ldy #25
		sta (m_p2),y

		lda manager_seldircolor_exp,x
                .else
nemp		ldy #0
		.BYTE SKIP2
nd		ldy #1

		sta cfg_open
		lax manager_seldircolor_exp,y
		lda manager_dircolor_exp,y
		sta cfg_16

		ldy #25
		sta (m_p2),y
		txa
                .fi

		iny
		sta (m_p2),y

                inc m_p3
                inc m_p1
                bne id
                inc m_p3+1
                inc m_p1+1

id		lda m_p4
		clc
		adc #32
		sta m_p4
		sta m_p2
		bcc *+4
		inc m_p2+1

		inc m_p5
		bne *+4
		inc m_p5+1
		bne p

null2		ldx man_selectedwin	;end of dir reached
		ldy #0
		lda (m_p2),y
		sta man_fulllo,x
		iny
		lda (m_p2),y
		sta man_fullhi,x

		ldy #9
		lda (m_p2),y
		sta man_fullfree,x

		clc
null		ldy #32
ig		lda pontpont-1,y
		sta man_pontpont-1,y
		dey
		bne ig
		tya
		sta man_block_l,x
		sta man_block_m,x
		sta man_block_h,x
		sta man_filessel_l,x
		sta man_filessel_h,x

		#sta_cfg_open
		lda manager_dircolor_exp
		#sta_cfg_16
		sta man_pontpont+25
		sta man_pontpont+26

		inc $1
                bcc man_ext.rt
		jsr read_errchannel
		#jmps showerror

pontpont	.word 0
		.text 34,".",".",0,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,"D","I","R","<",32,32,32,0,1,1
part		.text "$=P"
		.pend
;---------------------------
; Get filetype into A,X,Y
;
man_ext		.proc
		dec $1
		ldy #21
		lda (m_p1),y
		pha
		iny
                .if SUPERCPU=1
		lda (m_p1),y
		tax
                .else
                lax (m_p1),y
                .fi
		iny
		lda (m_p1),y
		tay
		pla
		inc $1
rt		rts
		.pend
;---------------------------
; Get selection
;
man_dir		#lda0
		ldy #25
                .byte SKIP2
man_sel		.proc
		ldy #26
		dec $1
		eor (m_p1),y
		php
		inc $1
		plp
		rts
		.pend
;---------------------------
; Copy filename to $201 like "sdfsdf,prg"
;
man_copyfname	.proc
		dec $1
		ldy #3
		ldx #0
ry		lda (m_p1),y
		beq iu
		sta $201,x
		inx
		iny
		bpl ry
iu		lda #","
		sta $201,x
		inx
		ldy #21
xp		lda (m_p1),y
		cmp #32
		beq wx
                cmp #"<"
                beq wx
		sta $201,x
		inx
		iny
		cpy #24
		bne xp
wx

		lda #<$201
		sta ActualFilename
		lda #>$201
		sta ActualFilename+1
		stx ActualFNLength
		stx $200
		inc $1
		rts
		.pend
;---------------------------
; Set filename length and position
;
man_setupfname	.proc
		dec $1
		ldy #2
fg		iny
		beq f
		lda (m_p1),y
		bne fg
f
		dey
		dey
		dey
		sty ActualFNLength

		lda m_p1
		clc
		adc #3
		sta ActualFilename
		lda m_p1+1
		adc #0
		sta ActualFilename+1
		inc $1
		rts
		.pend
;---------------------------
; Toggle selection
;
man_toggle_sel	.proc
		lda m_p1+1
		cmp #>man_dirmem1
		bcc tu
		dec $1
		ldy #26
		lda (m_p1),y
		eor #128
		sta (m_p1),y
		asl
		ldx man_selectedwin
		ldy #0
		lda man_block_l,x
		bcs nc
		sec
		sbc (m_p1),y
		sta man_block_l,x
		lda man_filessel_l,x
		bne hp
		dec man_filessel_h,x
hp		dec man_filessel_l,x
		iny
		lda man_block_m,x
		sbc (m_p1),y
		bcs nc2
		dec man_block_h,x
		gcc nc2

nc		inc man_filessel_l,x
		bne hp2
		inc man_filessel_h,x
hp2		clc
		adc (m_p1),y
		sta man_block_l,x
		iny
		lda man_block_m,x
		adc (m_p1),y
		bcc nc2
		inc man_block_h,x
nc2		sta man_block_m,x
		inc $1
tu		rts
		.pend

;		.if *>$b267
;		.error "bug!"
;		.fi
;		*=$b267
;		.byte 0			;b267

;---------------------------
; Quicksort directory list (if not on floppy)
;
sortdir		.proc
		ldx man_selectedwin

		lda man_files_l,x
		ora man_files_h,x
		beq err

		ldy man_floppy,x
		bne err			;no sorting for floppy

		iny
		sty man_l_l+63
		sty man_i_l+63
		sty man_l_h+63
		sty man_i_h+63

		lda sortm,x       
                sta m_ascii+1

		lda man_files_l,x
		sec
		sbc #1
		sta man_r_l+63
		lda man_files_h,x
		sbc #255
		sta man_r_h+63

		lda man_l_l+63
		cmp man_r_l+63
		lda man_l_h+63
		sbc man_r_h+63
		bge err
		dec $1
		sei
		ldx #64
		jsr quicksort
		cli
		inc $1
err		inx
		rts

quicksort	dex
		beq err
		lda man_r_l,x		;j=r
		sta man_j_l,x
		clc
		adc man_l_l,x
                .if SUPERCPU=1
                xba
                .else
		pha
                .fi
		lda man_r_h,x
		sta man_j_h,x
		adc man_l_h,x
		ror
		tay
                .if SUPERCPU=1
                xba
                .else
		pla
                .fi
		ror
		cpy #2
		jsr calc_filepos	;buf1=xx[(l+r)/2]
		lda m_p1
		sta m_p2
		lda m_p1+1
		sta m_p2+1

repeat
lp1		lda man_i_l,x
		ldy man_i_h,x
		cpy #2
		jsr calc_filepos

		ldy #25
		lda (m_p1),y
		bpl e11

		lda (m_p2),y
		bpl nn1n
		gmi ee1

e11		lda (m_p2),y
		bmi i

ee1		ldy #3
l1		lda (m_p2),y
		beq i
		cmp (m_p1),y
		bne nn1
		iny
		bne l1
		geq i

nn1		bcc i

nn1n		inc man_i_l,x
		bne lp1
		inc man_i_h,x
		#jmps lp1
i

lp2		lda man_j_l,x
		ldy man_j_h,x
		cpy #2
		jsr calc_filepos

		ldy #25
		lda (m_p2),y
		bpl e22

		lda (m_p1),y
		bpl nn2n
		gmi ee2

e22		lda (m_p1),y
		bmi i2

ee2		ldy #3
l2		lda (m_p1),y
		beq i2
		cmp (m_p2),y
		bne nn2
ok2		iny
		bne l2
		geq i2

nn2		bcc i2

nn2n		lda man_j_l,x
		bne rp
		dec man_j_h,x
rp		dec man_j_l,x
		#jmps lp2

i2
		lda man_j_l,x		;if (i<=j)
		cmp man_i_l,x
		lda man_j_h,x
		sbc man_i_h,x
		blt th

		lda man_i_h,x
                cmp #2
		lda m_ascii+1
                adc #0
		sta m_p1+1
		adc #2
		sta m_p3+1

		lda man_j_h,x
                cmp #2
		lda m_ascii+1
                adc #0
		sta m_p4+1
		adc #2
		sta m_p5+1

		lda man_i_l,x
		sta m_p1
		sta m_p3

		lda man_j_l,x
		sta m_p4
		sta m_p5
		bne rr2
		dec man_j_h,x
rr2		dec man_j_l,x

		inc man_i_l,x
		bne rr
		inc man_i_h,x
rr

                .if SUPERCPU=1
                lda (m_p1)
                xba
                lda (m_p4)
                sta (m_p1)
                xba
                sta (m_p4)

                lda (m_p3)
                xba
                lda (m_p5)
                sta (m_p3)
                xba
                sta (m_p5)
                .else
		ldy #0
                stx m_ascii

                lax (m_p1),y
                lda (m_p4),y
                sta (m_p1),y
                txa
                sta (m_p4),y

		lax (m_p3),y
		lda (m_p5),y
		sta (m_p3),y
                txa
		sta (m_p5),y

                ldx m_ascii
                .fi
th
		lda man_j_l,x		;if (i<=j)
		cmp man_i_l,x
		lda man_j_h,x
		sbc man_i_h,x
		bge repeat

		lda man_l_l,x
		cmp man_j_l,x
		lda man_l_h,x
		sbc man_j_h,x
		bge n1

		lda man_l_l,x
		sta man_l_l-1,x
		sta man_i_l-1,x
		lda man_l_h,x
		sta man_l_h-1,x
		sta man_i_h-1,x
		lda man_j_l,x
		sta man_r_l-1,x
		lda man_j_h,x
		sta man_r_h-1,x
		jsr quicksort
n1
		lda man_i_l,x
		cmp man_r_l,x
		lda man_i_h,x
		sbc man_r_h,x
		bge n2

		lda man_i_l,x
		sta man_l_l-1,x
		sta man_i_l-1,x
		lda man_i_h,x
		sta man_l_h-1,x
		sta man_i_h-1,x
		lda man_r_l,x
		sta man_r_l-1,x
		lda man_r_h,x
		sta man_r_h-1,x
		jsr quicksort
n2
		inx
		rts
		.pend
;---------------------------
; Calc the memory location of file under the cursor
;
calc_filepos_cursor .proc
		ldx man_selectedwin
		lda man_el_l,x
		clc
		adc man_bar,x
		bcs calc_filepos
		ldy man_el_h,x
		cpy #1
;---------------------------
; Calc the memory location of file
;
calc_filepos	.proc
		tay
		lda man_selectedwin
		bcc e
		bne ee1

		lda man_sort1_l+256,y
		sta m_p1
		lda man_sort1_h+256,y
		sta m_p1+1
		rts

ee1		lda man_sort2_l+256,y
		sta m_p1
		lda man_sort2_h+256,y
		sta m_p1+1
		rts

e		bne ee2

		lda man_sort1_l,y
		sta m_p1
		lda man_sort1_h,y
		sta m_p1+1
		rts

ee2		lda man_sort2_l,y
		sta m_p1
		lda man_sort2_h,y
		sta m_p1+1
		rts
		.pend
;---------------------------
; Plugin selection based on type of file
; FIXME!
;
man_plugin	.proc
		dec $1
		ldx #pl2-pl1-1
uk		lda pl1,x
		sta cconv+12
		ldy #21
		cmp (m_p1),y
		bne x
		lda pl2,x
		sta cconv+13
		iny
		cmp (m_p1),y
		bne x
		lda pl3,x
		sta cconv+14
		iny
		cmp (m_p1),y
		beq q
x		dex
		bpl uk
                clc
q		inc $1
		rts

pl1		.text "AAAAADDDFFHIKLLMSSSTX"
pl2		.text "FMNRS6RRLUPFLBNPHHI65"
pl3		.text "LIIKM4LPINILARXIFID4S"

		.pend
                
;---------------------------
; Copy panel information
;
man_copypanel	.proc
		dec $1
                ldx man_selectedwin+1
                lda dirm,x
                sta m_p1+1
                lda dirm+1,x
                sta m_p2+1
                sta m_p3+1

                lda man_files_h,x
                lsr
                lda man_files_l,x
                ror
                lsr
                lsr
                pha
                tax
                lda #$e0
                jsr copy

                ldx man_selectedwin
                lda sortm+1,x
                sta m_p1+1
                lda sortm,x
                sta m_p2+1
                lda #<man_sort1_l
                ldx #1
                jsr copy
                ldy #0
                ldx #1
ndv             lda (m_p1),y
                cmp #$20
                bcc vb2
                cmp #$60
                bcs vb
                adc #$81
vb              sbc #$40
vb2             sta (m_p2),y
                iny
                bne ndv
                inc m_p1+1
                inc m_p2+1
                dex
                bpl ndv

		ldy man_selectedwin+1
		ldx man_selectedwin
                lda man_files_l,y
		sta man_files_l,x
		lda man_files_h,y
		sta man_files_h,x
		lda man_fulllo,y
		sta man_fulllo,x
		lda man_fullhi,y
		sta man_fullhi,x
		lda man_fullfree,y
		sta man_fullfree,x
		lda man_partition,y
		sta man_partition,x
                #lda0
                sta man_block_l,x
		sta man_block_m,x
		sta man_block_h,x
		sta man_filessel_l,x
		sta man_filessel_h,x
                sta m_p3
		inc m_p3+1
                #plx_a
                ldy #26
ksd2            clc
ksd             lda (m_p3),y
                and #$7f
                sta (m_p3),y
                tya
                adc #32
                tay
                bcc ksd
                inc m_p3+1
                dex
                bpl ksd2
                inc $1
                rts

copy            ldy #0
                sta m_p1
                sta m_p2
nvd             lda (m_p1),y
                sta (m_p2),y
                iny
                bne nvd
                inc m_p1+1
                inc m_p2+1
                dex
                bpl nvd
		rts
		.pend

sortm		.byte >man_sort1_l
		.byte >man_sort2_l
                .byte >man_sort1_l

dirm		.byte >(man_dirmem1-$e0)
		.byte >(man_dirmem2-$e0)
		.byte >(man_dirmem1-$e0)

		.if *>$b447
		.error "bug!"
		.fi
		*=$b447
		.byte 0			;b447

		.if *>$b454
		.error "bug!"
		.fi
		*=$b454
		.byte 0,0      		;b454 b455
